#define VSHIFTING ( tire antiRotation for occlusion )
precision highp float;
uniform sampler2D tex1;
uniform sampler2D tex2;
	uniform lowp vec4 u_RimColor;
#define specColor vec3(0.05,0.05,0.05)
#define diffColor vec3(0.021,0.021,0.021)
#define ambColor vec3(0.005,0.005,0.005)
#define specSoftColor vec3(0.1,0.1,0.1)
const float Glossiness = float(2.105774); // const-optimized by shader optimizer!
const float vShift = float(-2.000000); // const-optimized by shader optimizer!
const float Highlight = float(0.000000); // const-optimized by shader optimizer!
const vec3 HighlightColor = vec3(0.000000, 0.000000, 0.000000); // const-optimized by shader optimizer!
varying vec3 normal, lightDir, eyeVec, tangent, binormal;
varying vec2 varCoord;
varying vec3 worldpos2;
vec3 EuclidianToSpherical(vec3 vector) {
    return vec3( atan( vector.x, vector.y )/(3.14*2.), - acos( vector.z )/3.14, 0 );
}
float torranceSparrow(vec3 N, vec3 V, vec3 L, float roughness) {
	vec3 H = normalize(L + V);
	float NdH = dot(N, H);
	float alpha = acos(NdH);
	float result = exp(-2. * roughness * pow(alpha, 2.));
	return smoothstep(0.0,0.1,dot(N,L)) * max(0.0,result);
}
void main (void) {
	vec4 final_color = vec4(0.,0.,0.,1.);
	vec3 N = normalize(normal.xyz);
	vec3 T = normalize(tangent.xyz);
	vec3 B = normalize(binormal.xyz);
	vec3 normalmap = texture2D(tex1,varCoord).xyz;
	normalmap *= 2.;
	normalmap -= 1.0;
	N += normalmap.x * T;
	N += normalmap.y * B;
	N = normalize(N);
	vec3 L = normalize(lightDir.xyz);
	vec3 E = normalize(eyeVec.xyz-worldpos2);
	vec3 R = reflect(L, N);
	final_color.xyz = ambColor;
	float lambertTerm = dot(N,L);
	final_color.xyz = mix( diffColor.xyz, HighlightColor, Highlight);
	final_color.xyz *= lambertTerm;
	float specular = pow( max(dot(R, -E), 0.0), Glossiness )*0.5;
	final_color.xyz += specSoftColor * specular;
	final_color.xyz *= normalmap.z;
	gl_FragColor.xyz = pow(final_color.xyz,vec3(0.65))*2.;
    gl_FragColor.xyz *= texture2D(tex2,varCoord+vec2(.0,vShift)).x;
		gl_FragColor += vec4(u_RimColor.x * u_RimColor.w, u_RimColor.y * u_RimColor.w, u_RimColor.z * u_RimColor.w, 0.0);
	gl_FragColor.w = 1.;
}