precision highp float;
uniform sampler2D tex1;
uniform vec3 specColor;
uniform vec3 diffColor;
uniform vec3 u_CameraWorldPosition;
const float Glossiness_Soft = float(7.000000); // const-optimized by shader optimizer!
const float Specularity = float(1.000000); // const-optimized by shader optimizer!
const float LightOnEco = float(0.000000); // const-optimized by shader optimizer!
const vec3 LightOnEcoColor = vec3(-0.500000, -0.250000, 0.000000); // const-optimized by shader optimizer!
const vec3 LightADir = vec3(-79.415764, -203.702057, 359.650146); // const-optimized by shader optimizer!
varying vec3 normal;
	varying vec3 tangent, binormal;
varying vec2 varCoord;
varying vec3 worldpos2;
varying vec4 col;
float trowbridgeReitz( float NdH, float roughness) {
	float result = pow(1. / (1. + (1. - (NdH*NdH)) * roughness), 2.);
	return result;
}
void main (void) {
	vec4 final_color = vec4(0.,0.,0.,1.);
	float gloss_soft = Glossiness_Soft;
vec4 normalmap = texture2D(tex1,varCoord);
float ambientOcc = normalmap.w;
	vec3 N = (normal.xyz);
	vec3 T = (tangent.xyz);
	vec3 B = (binormal.xyz);
	normalmap.xy *= 2.;
	normalmap.xy -= 1.0;
	N += normalmap.x * T;
	N += normalmap.y * B;
	N = normalize(N);
	vec3 L = normalize(LightADir.xyz);
	L.y *= -sign( worldpos2.y );
	vec3 E = normalize(u_CameraWorldPosition.xyz-worldpos2);
	vec3 R = -normalize(-E-L);
	float lambertTerm = clamp(dot(N,L),0.,1.);
	final_color.xyz = diffColor * lambertTerm;
	vec3 specColSoft = lambertTerm * specColor * Specularity;
	vec3 specColHard = specColSoft;
	float specular = trowbridgeReitz( dot(N,L), gloss_soft);
	final_color.xyz += specColor * specular * Specularity;
	gl_FragColor.xyz = sqrt(final_color.xyz);
    gl_FragColor.w = 1.;
	vec3 light;
	light = (col.g+col.b) * ( vec3(0.9,0.95,1.0) + LightOnEco * LightOnEcoColor );
	light += (col.r) * vec3(0.8,0.4,0.2)*2.;
	light *= normalmap.z;
	gl_FragColor.xyz += light;
	gl_FragColor.w = 1.;
	gl_FragColor.xyz *= ambientOcc;
	gl_FragColor.xyz += LightOnEco * LightOnEcoColor *0.2;
	gl_FragColor.xyz *= col.w;
}